package nl.dragontamerfred.lagmon;

import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class Config {

    public static String BROADCAST_FORMAT;
    public static long BROADCAST_INTERVAL;

    public static boolean CPU_DISCARD_NEGATIVE;
    public static int CPU_SAMPLE_TIME;

    public static String MEMORY_PROVIDER;
    public static int MEMORY_PTERODACTYL_POLLING_RATE;
    public static String MEMORY_PTERODACTYL_BASE_URL;
    public static String MEMORY_PTERODACTYL_SERVER_ID;
    public static String MEMORY_PTERODACTYL_API_TOKEN;

    public static int RESTART_PERCENTAGE;
    public static String RESTART_MESSAGE_NO_PERM;
    public static String RESTART_MESSAGE_VOTE_STARTED;
    public static String RESTART_MESSAGE_VOTE_UPDATE;
    public static String RESTART_MESSAGE_VOTE_CANCELED;
    public static String RESTART_MESSAGE_VOTE_PASSED;
    public static String RESTART_MESSAGE_VOTE_RESTARTING;
    public static String RESART_MESSAGE_RESTART_IN;

    public static void load(File file) {
        try {
            if (!file.getParentFile().exists())
                file.getParentFile().mkdirs();
            if (!file.exists())
                Util.ExportResource("/config.yml", file);
            YamlConfiguration config = new YamlConfiguration();
            config.load(file);

            BROADCAST_FORMAT = config.getString("broadcast.format");
            BROADCAST_INTERVAL = config.getLong("broadcast.interval");

            CPU_DISCARD_NEGATIVE = config.getBoolean("cpu.discard-negative");
            CPU_SAMPLE_TIME = config.getInt("cpu.sample-time");

            MEMORY_PROVIDER = config.getString("memory.provider");
            MEMORY_PTERODACTYL_POLLING_RATE = config.getInt("memory.pterodactyl.polling-rate");
            MEMORY_PTERODACTYL_BASE_URL = config.getString("memory.pterodactyl.base-url");
            MEMORY_PTERODACTYL_SERVER_ID = config.getString("memory.pterodactyl.server-id");
            MEMORY_PTERODACTYL_API_TOKEN = config.getString("memory.pterodactyl.api-token");

            RESTART_PERCENTAGE = config.getInt("restart.percentage");
            RESTART_MESSAGE_NO_PERM = config.getString("restart.messages.no-perm");
            RESTART_MESSAGE_VOTE_STARTED = config.getString("restart.messages.vote-started");
            RESTART_MESSAGE_VOTE_UPDATE = config.getString("restart.messages.vote-update");
            RESTART_MESSAGE_VOTE_CANCELED = config.getString("restart.messages.vote-canceled");
            RESTART_MESSAGE_VOTE_PASSED = config.getString("restart.messages.vote-passed");
            RESTART_MESSAGE_VOTE_RESTARTING = config.getString("restart.messages.vote-restarting");
            RESART_MESSAGE_RESTART_IN = config.getString("restart.messages.resarting-in");

        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }
}
