package nl.dragontamerfred.lagmon;

import nl.dragontamerfred.lagmon.commands.CommandLmrestart;
import nl.dragontamerfred.lagmon.components.ComponentBroadcast;
import nl.dragontamerfred.lagmon.components.ComponentCPU;
import nl.dragontamerfred.lagmon.components.ComponentMemory;
import nl.dragontamerfred.lagmon.components.ComponentTPS;
import nl.dragontamerfred.lagmon.components.memory.ProviderRuntime;
import nl.dragontamerfred.lagmon.components.memory.ProviderPterodactyl;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;

public final class LagMon extends JavaPlugin {

    public static LagMon plugin;

    @Override
    public void onEnable() {
        plugin = this;
        Config.load(new File(getDataFolder(), "config.yml"));

        ComponentTPS.startScheduler(this);
        ComponentCPU.startScheduler(this);
        if ("pterodactyl".equals(Config.MEMORY_PROVIDER))
            ComponentMemory.setup(new ProviderPterodactyl());
        else
            ComponentMemory.setup(new ProviderRuntime());

        ComponentBroadcast.startScheduler(this);


        // Register commands
        CommandLmrestart commandLmrestart = new CommandLmrestart();
        getCommand("lmrestart").setExecutor(commandLmrestart);
        getCommand("lmrestart").setTabCompleter(commandLmrestart);
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }
}
