package nl.dragontamerfred.lagmon;

import org.bukkit.ChatColor;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

public class Util {

    public static final long BYTES_PER_MB = 1048576;


    /**
     * Convert the amount of memory in bytes to the correct amount in MegaBytes as string.
     * @param mem The amount of memory in bytes (as long)
     * @return The amount of memory in MegaBytes (as String)
     */
    public static String formatMemory(long mem) {
        return Long.toString(mem / BYTES_PER_MB);
    }

    public static String color(String str) {
        return ChatColor.translateAlternateColorCodes('&', str);
    }

    /*
    Method to export a file from the jar to the plugin folder.
     */
    public static void ExportResource(String resourceName, File output) {
        try (InputStream stream = LagMon.class.getResourceAsStream(resourceName); OutputStream resStreamOut = new FileOutputStream(output)) {
            if (stream == null) {
                throw new Exception("Cannot get resource \"" + resourceName + "\" from Jar file.");
            }

            int readBytes;
            byte[] buffer = new byte[4096];
            while ((readBytes = stream.read(buffer)) > 0) {
                resStreamOut.write(buffer, 0, readBytes);
            }
        } catch (Exception ex) {
            //Fail silently
        }
    }
}
