package nl.dragontamerfred.lagmon.commands.lmrestart;

import nl.dragontamerfred.lagmon.Config;
import nl.dragontamerfred.lagmon.Util;
import nl.dragontamerfred.lagmon.components.ComponentRestart;
import nl.dragontamerfred.lagmon.types.ICommand;
import nl.dragontamerfred.lagmon.types.ISubCommand;
import org.bukkit.command.CommandSender;

public class Vote implements ISubCommand {

    @Override
    public String getName() {
        return "vote";
    }

    @Override
    public String getDescription() {
        return "Vote for a server restart.";
    }

    @Override
    public String getPermission() {
        return "lagmon.restart.vote";
    }

    @Override
    public boolean execute(ICommand command, CommandSender sender, String[] args) {
        switch (ComponentRestart.getStatus()) {
            case ENDED:
                sender.sendMessage(Util.color(Config.RESTART_MESSAGE_VOTE_RESTARTING));
                break;
            case STARTED:
                ComponentRestart.addVote(sender.getName());
                break;
            case STOPPED:
                ComponentRestart.startVote(sender.getName());
                break;
        }
        return true;
    }
}
