package nl.dragontamerfred.lagmon.components;

import nl.dragontamerfred.lagmon.Config;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.plugin.Plugin;

import java.lang.management.ManagementFactory;

public class ComponentCPU {

    private static float cpu;

    public static void startScheduler(Plugin plugin) {
        Bukkit.getScheduler().runTaskTimer(plugin, new Timer(), 0, Config.CPU_SAMPLE_TIME);
    }

    public static float getCpuRaw() {
        return cpu;
    }

    public static String getCPU() {
        return String.format("%.2f", cpu);
    }

    public static String getCPUColored() {
        if (cpu <= 25) {
            return ChatColor.GREEN + getCPU();
        } else if (cpu <= 75) {
            return ChatColor.YELLOW + getCPU();
        } else {
            return ChatColor.RED + getCPU();
        }
    }

    private static class Timer implements Runnable {
        long lastTotal = 0;
        long lastTime = 0;

        @Override
        public void run() {
            long totalCPUTime = 0;
            for (long id : ManagementFactory.getThreadMXBean().getAllThreadIds()) {
                totalCPUTime += ManagementFactory.getThreadMXBean().getThreadCpuTime(id);
            }

            float correctedTotal = (totalCPUTime - lastTotal) / 1000000.0f;
            long correctedTime = System.currentTimeMillis() - lastTime;
            float percentage = 100.0f * correctedTotal / correctedTime;

            if (!Config.CPU_DISCARD_NEGATIVE || percentage >= 0)
                cpu = percentage;

            lastTotal = totalCPUTime;
            lastTime = System.currentTimeMillis();
        }
    }
}
