package nl.dragontamerfred.lagmon.components;

import nl.dragontamerfred.lagmon.Util;
import nl.dragontamerfred.lagmon.components.memory.IMemoryProvider;
import org.bukkit.ChatColor;

public class ComponentMemory {

    private static IMemoryProvider provider;

    public static void setup(IMemoryProvider mprovider) {
        provider = mprovider;
    }

    public static String getFree() {
        return Util.formatMemory(provider.getFreeRaw());
    }

    public static String getMax() {
        return Util.formatMemory(provider.getMaxRaw());
    }

    public static String getUsed() {
        return Util.formatMemory(provider.getUsedRaw());
    }

    public static String getFreeColored() {
        long free = provider.getFreeRaw();
        long total = provider.getMaxRaw();

        double percentage = 100.0 * free / total;

        if (percentage >= 50) {
            return ChatColor.GREEN + getFree();
        } else if (percentage >= 10) {
            return ChatColor.YELLOW + getFree();
        } else {
            return ChatColor.RED + getFree();
        }
    }

    public static String getUsedColored() {
        long used = provider.getUsedRaw();
        long total = provider.getMaxRaw();

        double percentage = 100.0 * used / total;

        if (percentage >= 90) {
            return ChatColor.RED + getUsed();
        } else if (percentage >= 50) {
            return ChatColor.YELLOW + getUsed();
        } else {
            return ChatColor.GREEN + getUsed();
        }
    }
}
